#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use LWP::Simple;
use LWP::UserAgent;
use HTTP::Request;  
use obbuild;

&get_setup;
$q = CGI->new;



acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES   

print "Content-type: text/html\n\n";

####################################

if ($q->param('fct') eq ""){&start;}
if ($q->param('fct') eq "docrawling"){&docrawling;}
if ($q->param('fct') eq "docrawling2"){&docrawling2;}

if ($q->param('fct') eq "add_crawled"){&add_crawled2;}
if ($q->param('fct') eq "add_crawled3"){&add_crawled3;}

if ($q->param('fct') eq "extract_urls1"){&extract_urls1;}



#####################################<input type="checkbox" name="$selname" value="Y" checked><strong>Add
#  This Listing</strong>

sub docrawling2
{



$cid = $q->param('cid');
$ct = $q->param('ct');
$category = acs::get_location_string($ct);
$timefile = $q->param('timefile');
$threads = $q->param('threads');
$total = $q->param('total');

$mdiz = $q->param('metadiz_ignore');
$mkey = $q->param('metakw_ignore');



if ($q->param('pos') eq "") 
	{
	$pos = 1; 
	}
	else
	{
	$pos = $q->param('pos');
	}



$modp = ($total % $threads);
$perthread = ($total - $modp) / $threads;
if ($modp != 0) {$perthread++;} 

$end_pos = ($pos * $perthread);
$start_pos = ($end_pos - $perthread);

#print "--> start: $start_pos <BR>";
#print "--> end: $end_pos <BR>";



my $ua = LWP::UserAgent-> new();
$ua->agent("Mozilla/4.0 (compatible; MSIE 5.5)");
#$ua->timeout($timeout);

$tpos = $q->param('tpos');
if ($tpos eq "") 
		{
		$tpos = $start_pos; 
		$tpos++;
		}


$pos_count = 0;
open (CFILE, "$data_dir/tmp/$timefile.crw");
	while (defined($line=<CFILE>))
		{
		$pos_count++;
		
		
		
			if (($pos_count > $start_pos) and ($pos_count <= $end_pos))
				{
				
				if (($pos_count == $tpos) and ($tpos <= $end_pos))
					{
				
					$crit1 = chr(13);$crit2 = chr(13);$line =~ s/$crit1//gi;$line =~ s/$crit2//gi; 
					$line =~ s/\n//g;
				
							my $req = HTTP::Request->new(GET => "$line"); 
							my $response = $ua->request($req);
							if ($response->is_success) 
								{
								my $content = $response->content();
								($title, $metadiz, $metakeys) = &get_meta_details($content);
								
								$rcfile = $timefile . "-" . $pos . ".crw1";
								
								$dont_write = "false";
								if (($mdiz eq "Y") and (length($metadiz) < 10)) { $dont_write = "true"; }
								if (($mkey eq "Y") and (length($metakeys) < 10)) { $dont_write = "true"; }
								
								if ($dont_write eq "false")
									{
									open (HSF, ">> $data_dir/tmp/$rcfile");
										print HSF $title . "\t" . $metadiz . "\t" . $metakeys .  "\t" . $line . "\n";
									close (HSF);
									}
								
								}
							
					$did_crawl = "$line";
					$lastpos = $tpos;
					}
				
				
				}
		
			
		}
close (CFILE);

$tpos++;


$did_crawl2 = substr($did_crawl, 0, 30); $did_crawl2 = $did_crawl2 . "...";


$lownr = $lastpos - $start_pos;
$highnr = $end_pos - $start_pos;

if (($lownr > 0) and ($highnr > 0))
	{
	$perc = ($lownr / $highnr) * 100;
	$perc = sprintf("%5.2f",$perc);  
	}
	else
	{
	$perc = "1.00";
	}
	

if ($did_crawl eq "") 
{

print qq[<html>
<head>
<title>Working...</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body topmargin="0" leftmargin="0">

<table width="100%" cellpadding="0" cellspacing="0" bgcolor="#FFFFFF"
style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="100%" height="30" class="normaltext"><strong>&nbsp; Crawl Completed. </strong></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</body>
</html>
];
exit;

}



print qq[<html>
<head>
<title>Working...</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin41.cgi?fct=docrawling2&cid=$cid&ct=$ct&timefile=$timefile&threads=$threads&total=$total&tpos=$tpos&pos=$pos">
</head>
<body>

<table width="100%" cellpadding="0" cellspacing="0" bgcolor="#FFFFFF"
style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="1%" height="30" class="normaltext"><img src="$web_url/working2.gif"></td>
    <td width="15%" class="normaltext" style="border-right: 1px solid rgb(221,221,221)"><p
    align="center"><strong>$perc% Complete</strong></td>
    <td width="35%" class="normaltext" style="border-right: 1px solid rgb(221,221,221)"><strong>
    &nbsp;&nbsp; Crawling: </strong>$did_crawl2</td>
    <td width="49%" class="normaltext"><table border="0" cellpadding="0" cellspacing="0"
    width="$perc%">
      <tr>
        <td width="100%" background="$web_url/bar.gif" height="30"></td>
      </tr>
    </table>
    </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>


</body>
</html>
];

}




sub get_meta_details
{
my ($html_code) = @_;
my ($meta_endpos, $title_chunk,  $meta_startpos, @all_lines, @dchnks1, $fline, $meta_title,$ret_meta_diz,$ret_kw_diz);

$html_code =~ s/\t/ /gi;
$html_code =~ s/\n/ /gi;
$mcrit = chr(10); $html_code =~ s/$mcrit/ /g;
$mcrit = chr(13); $html_code =~ s/$mcrit/ /g; 


$html_code =~ s/</\n</gi;
$html_code =~ s/>/>\n/gi;

$html_code =~ s/<\/font>//gi;
$html_code =~ s/<\/font \/>//gi;

### TITLE

if ($html_code =~ m/<\/title>/gi) { $meta_endpos = pos($html_code); }

$title_chunk = substr($html_code, 0, $meta_endpos - 8);

if ($title_chunk =~ m/<title>/gi) { $meta_startpos = pos($title_chunk); }
$meta_title = substr($title_chunk, $meta_startpos, length($title_chunk));

$meta_title =~ s/\t/ /gi;
$meta_title =~ s/\n//gi;
$mcrit = chr(10); $meta_title =~ s/$mcrit//g;
$mcrit = chr(13); $meta_title =~ s/$mcrit//g; 





### META DIZ

@all_lines = split(/\n/, $html_code);

foreach $fline (@all_lines)
	{
	if (($fline =~ /<meta/i) and ($fline =~ /description/i) and ($fline =~ /content/i))
		{
		if ($fline =~ m/content/gi) { $meta_ds_start = pos($fline); }
		$diz_chunk = substr ($fline, $meta_ds_start, length($fline) - $meta_ds_start);
		@dchnks = split (/\=/, $diz_chunk);
		$ret_meta_diz = $dchnks[1];
		$ret_meta_diz  =~ s/"//g; $ret_meta_diz  =~ s/\/>//g; $ret_meta_diz =~ s/>//g;
		
		$ret_meta_diz =~ s/\t/ /gi;
		$ret_meta_diz =~ s/\n//gi;
		$mcrit = chr(10); $ret_meta_diz =~ s/$mcrit//g;
		$mcrit = chr(13); $ret_meta_diz =~ s/$mcrit//g; 
		}

	if (($fline =~ /<meta/i) and ($fline =~ /keywords/i) and ($fline =~ /content/i))
		{
		if ($fline =~ m/keywords/gi) { $meta_ds_start = pos($fline); }
		$diz_chunk = substr ($fline, $meta_ds_start, length($fline) - $meta_ds_start);
		@dchnks1 = split (/\=/, $diz_chunk);
		$ret_kw_diz = $dchnks1[1];
		$ret_kw_diz  =~ s/"//g; $ret_kw_diz  =~ s/\/>//g; $ret_kw_diz =~ s/>//g;
		
		$ret_kw_diz =~ s/\t/ /gi;
		$ret_kw_diz =~ s/\n//gi;
		$mcrit = chr(10); $ret_kw_diz =~ s/$mcrit//g;
		$mcrit = chr(13); $ret_kw_diz =~ s/$mcrit//g; 
		}
		
	
	}


return ($meta_title,$ret_meta_diz,$ret_kw_diz);

}






sub add_crawled2
{

$cid = $q->param('cid');
$ct = $q->param('ct');
$category = acs::get_location_string($ct);
$nrs = $q->param('nrs');
$timefile = $q->param('timefile');

$mdiz = $q->param('metadiz_ignore');
$mkey = $q->param('metakw_ignore');

$hbox = acs::get_heading_box("$web_url/ic_crawl2.gif", "Add Crawled Links to: $category", qq[Check the checkbox with each link to include it into: <b>$category</b>]);


opendir(DIR,"$data_dir/tmp");
@files = readdir(DIR);

$cnt = 0;

foreach $filename (@files)
	{
	if ((substr($filename, 0, length($timefile)) eq $timefile) and (substr($filename, length($filename) - 5, 5) eq ".crw1"))
		{ 
		$fcontents = acs::get_file_contents("$data_dir/tmp/$filename");  
		@flines = split (/\n/, $fcontents);
		
		foreach $iline (@flines)
			{
			
			($c_title, $c_diz, $c_kw, $c_url) = split (/\t/, $iline);
			
			$checkbox_name = "C" . $cnt;
			$title_name = "title" . $cnt;
			$diz_name = "diz" . $cnt;
			$keyw_name = "keyw" . $cnt;
			$url_name = "url" . $cnt;
			

			$dont_write = "false";
			if (($mdiz eq "Y") and (length($c_diz) < 10)) { $dont_write = "true"; }
			if (($mkey eq "Y") and (length($c_kw) < 10)) { $dont_write = "true"; }
			

			if ($dont_write eq "false")
			{
			
			$cnt++;

$content_boxes = $content_boxes . qq[<table width="100%" cellpadding="6" cellspacing="1" bgcolor="#FFFFFF" style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="25%" height="30" class="normaltext" background="$web_url/bar6.gif">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="1%"><strong>
<input type="checkbox" name="$checkbox_name" value="Y"></strong></td>
        <td width="99%" class="normaltext"><strong>(check to include)</strong></td>
      </tr>
    </table>
    </td>
    <td width="75%" height="30" class="normaltext" background="$web_url/bar6.gif"><strong>$cnt. Crawled Link Details:</strong></td>
  </tr>
  <tr>
    <td width="25%" height="30" class="normaltext">Title: </td>
    <td width="75%" height="30" class="normaltext">
<input type="text" name="$title_name" size="20" value="$c_title" style="width:100%"></td>
  </tr>
  <tr>
    <td width="25%" height="30" class="normaltext" valign="top">Description:</td>
    <td width="75%" height="30" class="normaltext">
<textarea rows="5" name="$diz_name" cols="50" style="width:100%">$c_diz</textarea></td>
  </tr>
  <tr>
    <td width="25%" height="30" class="normaltext" valign="top">Keywords:</td>
    <td width="75%" height="30" class="normaltext">
<textarea rows="5" name="$keyw_name" cols="50" style="width:100%">$c_kw</textarea></td>
  </tr>
  <tr>
    <td width="25%" height="30" class="normaltext">URL:</td>
    <td width="75%" height="30" class="normaltext">
<input type="text" name="$url_name" size="43" value="$c_url" style="width:100%"></td>
  </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
];
			 }
			 
			}
		
		}
	}
 
 
if ($cnt < 1)
	{
	$hbox = acs::get_heading_box("$web_url/ic_crawl2.gif", "No links were available", qq[Could not find any links to add. This may be due to requiring links to have a meta description or meta keywords. It may also be due to connection related problems, file not found issues, or other issues.
	
	<BR><a href="$admin_url/admin41.cgi?cid=$cid&ct=$ct">Click here to continue</a>]);
	print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html>
];
	exit;
	}
 
 
print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox

<form method="POST" action="$admin_url/admin41.cgi">
$content_boxes

<input type="hidden" name="fct" value="add_crawled3">
<input type="hidden" name="ct" value="$ct">
<input type="hidden" name="total_items" value="$cnt">
<input type="hidden" name="timefile" value="$timefile">
<input type="hidden" name="cid" value="$cid">

<table width="100%" cellpadding="6" cellspacing="1" bgcolor="#FFFFFF"
style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="25%" height="30" class="normaltext" align="center"></td>
    <td width="75%" height="30" class="normaltext">

	 <input type="checkbox" name="duplicates" value="Y">Prevent Duplicates (Crawled Items with the same URL won't be added to the database)
    <BR><BR>
    <input type="submit" value="Add Checked Crawled Items" name="B1"><p>Checked items will be added to: <strong>$category</strong></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>


</form>

</body>
</html> 
];


}





sub add_crawled3
{

$cid = $q->param('cid');
$ct = $q->param('ct');
$category = acs::get_location_string($ct);
$total_items = $q->param('total_items');
$timefile = $q->param('timefile');
$duplicates = $q->param('duplicates');



for ($ms = 0; $ms < $total_items; $ms++) 
    {
	 $chname = "C" . $ms;
	 
	 if ($q->param($chname) eq "Y")
	 	{
	 	$found_item = "true";

		$add_title = "title" . $ms;
	 	$add_title = $q->param($add_title);
	 	
		$add_diz = "diz" . $ms;
	 	$add_diz = $q->param($add_diz);

		$add_keyw = "keyw" . $ms;
	 	$add_keyw = $q->param($add_keyw);

		$add_url = "url" . $ms;
	 	$add_url = $q->param($add_url);
	 	
	 	$add_details = "$add_title" . "::o-::" . $add_diz . "::o-::" . $add_keyw . "::o-::" . $add_url;
	 	
	 	push(@addlist, $add_details)
	 	}
	 }


if ($found_item ne "true") { acs::problem_popup("You have to check something to add it to the database."); }



##########################



if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

	if ($duplicates eq "Y")
	{
	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh1 = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh1 ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 
	}


$sql = qq{INSERT INTO links SET  cid = ?,
				title = ?,
				description = ?,
				keywords = ?,
				url = ?,
				urldate = ?
	 };

$sth = $dbh->prepare($sql);
$serror = ""; $serror = $sth->errstr; obbuild::sqlerror($serror); if ($serror ne "") {die "SQL Syntax Error: $serror";}

$time = time();
$acount = 0;

foreach $item (@addlist)
	{
	($title, $diz, $key, $url) = split (/::o-::/, $item);

	$found_dup = "false";
	
		if ($duplicates eq "Y")
		{
 		$sth1 = $dbh1->prepare("SELECT url FROM links WHERE url = '$url'"); 
		if ( !defined $dbh1 ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
		$sth1->execute;
		$serror = ""; $serror = $sth1->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
		$rows = $sth1->rows(); #dbi mod
		
		if ($rows > 0)
		{ 
			  $duplinks = $duplinks . qq[ <tr>
	  		  <td width="11%" class="normaltext"><strong>
	  		  Title: </strong></td>
	  		  <td width="89%" class="normaltext">
	  		  <a href="$url" target="_blank">$title</a>
	  		  </td>
	  		</tr>
	  		<tr>
	  		  <td width="11%" class="normaltext" valign="top"><strong>Description:</strong></td>
	  		  <td width="89%" class="normaltext">$diz</td>
	  		</tr>
	  		<tr>
	  		  <td width="11%" class="normaltext" valign="top"><strong>Keywords:</strong></td>
	  		  <td width="89%" class="normaltext">$key</td>
	  		</tr>
	  		<tr>
	  		  <td width="11%" class="normaltext" valign="top"
	  		  style="border-bottom: 1px solid rgb(221,221,221)"><strong>URL: </strong></td>
	  		  <td width="89%" class="normaltext" style="border-bottom: 1px solid rgb(221,221,221)">$url</td>
	  		</tr>
			];
			  $found_dup = "true";
			 }
	   }


###########


	if ($found_dup eq "false")
		{
	
	
			$sth->bind_param(1, $cid); 					### cid
			$sth->bind_param(2, $title);					### title
			$sth->bind_param(3, $diz);						### description
			$sth->bind_param(4, $key);						### keywords
			$sth->bind_param(5, $url);						### url	
			$sth->bind_param(6, $time);					### date
		   	
  			$sth->execute;
  			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
		   	
  			$added_links = $added_links . qq[<tr>
    <td width="11%" class="normaltext" valign="top"><strong>Title: </strong></td>
    <td width="89%" class="normaltext"><a href="$url" target="_blank">$title</a></td>
  </tr>
  <tr>
    <td width="11%" class="normaltext" valign="top"><strong>Description:</strong></td>
    <td width="89%" class="normaltext">$diz</td>
  </tr>
  <tr>
    <td width="11%" class="normaltext" valign="top"><strong>Keywords:</strong></td>
    <td width="89%" class="normaltext">$key</td>
  </tr>
  <tr>
    <td width="11%" class="normaltext"  style="border-bottom: 1px solid rgb(221,221,221)" valign="top"><strong>URL: </strong></td>
    <td width="89%" class="normaltext" style="border-bottom: 1px solid rgb(221,221,221)">$url</td>
  </tr>];
  
  			$acount++;	
  		}

	}
 



$sth->finish;
$dbh->disconnect;

if ($duplicates eq "Y")
	{
	$sth1->finish;
	$dbh1->disconnect;
	}


if ($duplinks ne "") 
	{ 
	$duplinks = qq[<table width="100%" cellpadding="6" cellspacing="1" bgcolor="#FFFFFF"
style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="100%" height="30" class="normaltext" background="$web_url/bar6.gif" colspan="2"><b>The
    following Links was not added as it would created duplicates:</b></td>
  </tr>] . $duplinks . qq[</table><table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>];

	}

$hbox = acs::get_heading_box("$web_url/ic_crawl2.gif", "Links Added to Database:", qq[
Click here to <a href="$admin_url/admin41.cgi?cid=$cid&ct=$ct">continue</a> or here to  <a href="javascript:onClick=window.close()">close</a> this window.
]);



if ($acount > 0)
	{
	acs::update_cat_numbers($cid, $acount);
	}




print qq[

<html>
<head>
<title>Working...</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body onUnload="opener.location.reload(true);"> 
$hbox
<table width="100%" cellpadding="6" cellspacing="1" bgcolor="#FFFFFF"
style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="100%" height="30" class="normaltext" background="$web_url/bar6.gif" colspan="2"><a
    name="added"></a>Links Added To<strong> $category:</strong></td>
  </tr>

$added_links
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

$duplinks

</body>
</html>

];


}









sub extract_urls
{

$cid = $q->param('cid');
$ct = $q->param('ct');
$extracturl = $q->param('extracturl');

$filter = $q->param('filter');
$filter=~ s/\n/::-::/g;

$hbox = acs::get_heading_box("$web_url/ic_crawl2.gif", "Extracting URLs from: $extracturl", qq[<img src="$web_url/working.gif">]);


print qq[

<html>
<head>
<title>Working...</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin41.cgi?fct=extract_urls1&ct=$ct&cid=$cid&extracturl=$extracturl&filter=$filter">
</head>
<body>
$hbox
</body>
</html> 


];


}



sub extract_urls1
{

if (($q->param('extracturl') eq "") or ($q->param('extracturl') eq "http://")) { acs::problem_popup("You have to specify a URL address to a web page where URLs can be extracted from."); }

my $ua = LWP::UserAgent-> new();
$ua->agent("Mozilla/4.0 (compatible; MSIE 5.5)");
my $req = HTTP::Request->new(GET => $q->param('extracturl'));
my $response = $ua->request($req);

if ($response->is_success) 
		{
		my $content = $response->content();
		my $status = $response->status_line;

		$e_urls = &extract_urls2($content);
		}
		

#print "$e_urls";

&start($e_urls);

}




sub extract_urls2
{
my ($html) = @_;



$html =~ s/\t/ /gi;
$html =~ s/\n/ /gi;
$mcrit = chr(10); $html =~ s/$mcrit/ /g;
$mcrit = chr(13); $html =~ s/$mcrit/ /g; 
 	
$html =~ s/</\n</gi;
$html =~ s/>/>\n/gi; 		
		
@all_lines = split (/\n/, $html);

foreach $line (@all_lines)
  {
  
  
	if ($line =~ /href/i)
		{
			if ($line =~ m/http:\/\//gi)
				{
				$begin_url = pos($line);
				$eurl = substr($line, $begin_url - 7, length($line));
				
					$foundm = ""; $rurl = "";
					for ($ms = 0; $ms <= length($eurl); $ms++)
						{
						  $letter = substr($eurl, $ms, 1);
						  
						  if (($letter eq ">") or ($letter eq " ") or ($letter eq "\"")) {$foundm = "true";}
						  
						  if ($foundm ne "true") {$rurl = $rurl . $letter;}
						  
						}
					
					
					### REMOVE DUPLICATES
					$no_add = "";
					foreach $url_item (@ulist)
						{
						if ($url_item eq $rurl) { $no_add = "true"; }
						}
					if ($no_add ne "true") { push(@ulist, $rurl); }
					
					
				
				}
		
		}
	
	
  }


if ($q->param('filter') ne "")
	{
	@filter_items = split(/::-::/, $q->param('filter'));
	}


foreach $item (@ulist)
	{
	
		$foundfmatch = "";
		foreach $filt_item (@filter_items)
			{
			if ($item =~ /$filt_item/i)
				{ 
				$foundfmatch = "true";
				}
			}
	
		if ($foundfmatch ne "true")
			{
			$ret_urls = $ret_urls . $item . "\n";
			}
	}

return ($ret_urls);

}







sub docrawling
{

if ($q->param('B3') ne "") { &extract_urls; exit;}

if ($q->param('urls') eq "") { acs::problem_popup("You have to specify URLs to crawl."); }
if ($q->param('threads') < 1) { acs::problem_popup("You have to a number for the number of threads to open."); }

if ($q->param('threads') > 100) { acs::problem_popup("The maximum threads you can use is 100."); }

$cid = $q->param('cid');
$ct = $q->param('ct');
$category = acs::get_location_string($ct);
$timefile = time();
$threads = $q->param('threads');

$metadiz_ignore = $q->param('metadiz_ignore');
$metakw_ignore = $q->param('metakw_ignore');

if ((-e "$data_dir/tmp") < 1)
	{ 
	mkdir ("$data_dir/tmp", $default_permissions);
	chmod($default_permissions,"$data_dir/tmp","$data_dir/tmp");
	} 

#########################

@titems = split (/\n/, $q->param('urls'));
$tcount = @titems;

open (CFILE, "> $data_dir/tmp/$timefile.crw");
	print CFILE $q->param('urls');
close (CFILE);


$hbox = acs::get_heading_box("$web_url/ic_crawl2.gif", "Crawling Links for: $category", qq[
Please wait untill all threads has been completed. Once complete <a href="$admin_url/admin41.cgi?fct=add_crawled&cid=$cid&ct=$ct&timefile=$timefile&metadiz_ignore=$metadiz_ignore&metakw_ignore=$metakw_ignore">click here</a> to add links to $category
]);


#$modp = ($tcount % $threads);
#$perthread = ($tcount - $modp) / $threads;
#if ($modp != 0) {$perthread++;} 


for ($ms = 1; $ms <= $threads; $ms++)
{

$iframe_details = $iframe_details . qq[
<iframe src="$admin_url/admin41.cgi?cid=$cid&ct=$ct&timefile=$timefile&fct=docrawling2&threads=$threads&total=$tcount&pos=$ms&metadiz_ignore=$metadiz_ignore&metakw_ignore=$metakw_ignore" width="100%" height="70" FRAMEBORDER=0 SCROLLING=NO></iframe> 
];

}

#<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin41.cgi?cid=$cid&ct=$ct&timefile=$timefile&fct=docrawling2&threads=$threads&total=$tcount"> 

print qq[
<html>
<head>
<title>Crawl - $category</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>

$hbox

$iframe_details

</body>
</html>
];


}




sub start
{

my ($ext_url_items) = @_;

opendir(DIR,"$data_dir/tmp");
@files = readdir(DIR);

$cnt = 0;


### CLEAN TMP DIR

$nowtime = time();
$old_time = $nowtime - 259200;


foreach $filename (@files)
	{
	if ((substr($filename, length($filename) - 5, 5) eq ".crw1") or (substr($filename, length($filename) - 4, 4) eq ".crw"))
		{ 
			($timefile, $tmp) = split (/\./, $filename);
			
			if ($timefile =~ /-/)
				{
				($timefile, $tmp) = split (/-/, $timefile);
				}
		
		if ($timefile < $old_time) { unlink ("$data_dir/tmp/$filename"); }
			
		}
	}




$cid = $q->param('cid');
$ct = $q->param('ct');
$category = acs::get_location_string($ct);


$hbox = acs::get_heading_box("$web_url/ic_crawl2.gif", "Crawl Links For: $category", qq[<ul>
  <li class="normaltext">The crawler will fetch titles, descriptions and keywords from meta tags where
    available. </li>
  <li class="normaltext">Do not add too many URLs at once as it may cause the browser to time-out or
    cause slow loading pages.  </li>
</ul>]);



print <<END_OF_IMPS;
<html>
<head>
<title>Crawl - $category</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>

$hbox

<form method="POST" action="$admin_url/admin41.cgi">
  <table width="100%" cellpadding="6" cellspacing="1" bgcolor="#FFFFFF" style="border: 1px solid rgb(219,219,219)">
    <tr>
      <td width="100%" height="30" background="$web_url/bar6.gif" class="normaltext"><strong>Add URLs to crawl below: </strong>(Each url should be on a new line) </td>
    </tr>
    <tr>
      <td height="30" class="normaltext"><textarea rows="20" name="urls" cols="84" style="width:100%">$ext_url_items</textarea>
      
      <p>
      
      <input type="checkbox" name="metadiz_ignore" value="Y">Ignore Crawled Items that doesn't have
		a <strong>Meta Description</strong><br>
		<input type="checkbox" name="metakw_ignore" value="Y">Ignore Crawled Items that doesn't have <strong>Meta
Keywords</strong>
      <BR><BR>

		<strong>Threads: </strong>
        <input name="threads" type="text" id="threads" value="10" size="10">
      <br>
      Threads speeds up crawling be creating more than one instance of the crawler to crawl multiple URLs at the same time)      
      
      </p>
      
      
      
      </td>
    </tr>
    <tr>
      <td height="30" class="normaltext"><label>
        <input type="submit" value="Start Crawling" name="B2">
        <input type="hidden" name="cid" value="$cid">
        <input type="hidden" name="ct" value="$ct">
        <input
  type="hidden" name="fct" value="docrawling">
</label></td>
    </tr>
  </table>
  
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
  </table>

  
  
  <table width="100%" cellpadding="6" cellspacing="1" bgcolor="#FFFFFF" style="border: 1px solid rgb(219,219,219)">
    <tr>
      <td width="100%" height="30" background="$web_url/bar6.gif" class="normaltext"><strong>Extract URLs from Web Page:  </strong></td>
    </tr>
    <tr>
      <td height="30" class="normaltext"><p>The 'Extract URLs' functionality lets you extract URLs from web pages (or URL addresses) so that they can be crawled.</p>
        <p><strong>URL to web page </strong><strong>where URLs should be extracted from:</strong><br>
          <label>
          <input name="extracturl" type="text" id="extracturl" value="http://" size="50" style="width:100%">
          </label>
        </p>
      <p><strong>URL Filter: <br>
      </strong>(URLs specified here will not be included when extracting URLs from the address specified above. You can only specify a domain name for example and any URLs from this domain name won't be included.)<br>
        <textarea rows="10" name="filter" cols="84" style="width:100%" id="filter"></textarea>
      </p>
      </td>
    </tr>
    <tr>
      <td height="30" class="normaltext"><label>
        <input type="submit" value="Extract URLs" name="B3">
      </label></td>
    </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

  
  </form>



</body>
</html>

END_OF_IMPS

}






####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

